Bug 1713468 (CVE-2019-12086) - CVE-2019-12086 jackson-databind: polymorphic typing issue allows attacker to read arbitrary local files on the server.
Summary: CVE-2019-12086 jackson-databind: polymorphic typing issue allows attacker to ...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2019-12086
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1713469 1724441 1724442 1724443 1730588 1731780 1731787 1731789 1731790 1731792 1732286 1732291 1732539
Blocks: 1713470
TreeView+ depends on / blocked
 
Reported: 2019-05-23 19:23 UTC by msiddiqu
Modified: 2020-07-28 15:54 UTC (History)
96 users (show)

Fixed In Version: jackson-databind 2.9.9
Doc Type: If docs needed, set a value
Doc Text:
A flaw was discovered in FasterXML jackson-databind, where it would permit polymorphic deserialization of malicious objects using the mysql gadget when used in conjunction with polymorphic type handling methods such as `enableDefaultTyping()` or when @JsonTypeInfo is using `Id.CLASS` or `Id.MINIMAL_CLASS` or in any other way which ObjectMapper.readValue might instantiate objects from unsafe sources. An attacker could use this flaw to read arbitrary local files
Clone Of:
Environment:
Last Closed: 2019-09-27 00:45:35 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:2858 None None None 2019-09-27 00:14:25 UTC
Red Hat Product Errata RHSA-2019:2935 None None None 2019-09-30 22:53:51 UTC
Red Hat Product Errata RHSA-2019:2936 None None None 2019-09-30 22:55:56 UTC
Red Hat Product Errata RHSA-2019:2937 None None None 2019-09-30 22:51:35 UTC
Red Hat Product Errata RHSA-2019:2938 None None None 2019-09-30 22:58:08 UTC
Red Hat Product Errata RHSA-2019:2998 None None None 2019-10-10 09:54:47 UTC
Red Hat Product Errata RHSA-2019:3044 None None None 2019-10-14 18:28:42 UTC
Red Hat Product Errata RHSA-2019:3045 None None None 2019-10-14 18:29:03 UTC
Red Hat Product Errata RHSA-2019:3046 None None None 2019-10-14 18:29:21 UTC
Red Hat Product Errata RHSA-2019:3050 None None None 2019-10-14 18:59:27 UTC
Red Hat Product Errata RHSA-2019:3149 None None None 2019-10-18 19:53:09 UTC
Red Hat Product Errata RHSA-2020:1454 None None None 2020-04-14 13:22:11 UTC
Red Hat Product Errata RHSA-2020:3192 None None None 2020-07-28 15:54:30 UTC

Description msiddiqu 2019-05-23 19:23:53 UTC
A Polymorphic Typing issue was discovered in FasterXML jackson-databind 2.x before 2.9.9. When Default Typing is enabled (either globally or for a specific property) for an externally exposed JSON endpoint, the service has the mysql-connector-java jar (8.0.14 or earlier) in the classpath, and an attacker can host a crafted MySQL server reachable by the victim, an attacker can send a crafted JSON message that allows them to read arbitrary local files on the server. This occurs because of missing com.mysql.cj.jdbc.admin.MiniAdmin validation.

Upstream patch:

https://github.com/FasterXML/jackson-databind/commit/dda513bd7251b4f32b7b60b1c13740e3b5a43024

Upstream issue:

https://github.com/FasterXML/jackson-databind/issues/2326

References:

https://github.com/FasterXML/jackson/wiki/Jackson-Release-2.9.9
https://issues.jboss.org/browse/RESTEASY-2248
http://russiansecurity.expert/2016/04/20/mysql-connect-file-read/
https://medium.com/@cowtowncoder/on-jackson-cves-dont-panic-here-is-what-you-need-to-know-54cd0d6e8062

Comment 1 msiddiqu 2019-05-23 19:24:10 UTC
Created jackson-databind tracking bugs for this issue:

Affects: fedora-all [bug 1713469]

Comment 3 Joshua Padman 2019-05-28 09:09:57 UTC
OpenDaylight in Red Hat OpenStack 9 & 10 was released as a technical preview and will not be receiving security updates.

Comment 4 Joshua Padman 2019-06-07 03:38:18 UTC
All versions of Red Hat OpenStack's OpenDaylight ships with the vulnerable package. However, OpenDaylight will not receive a fix for this issue at this time.

Comment 15 Jason Shepherd 2019-08-08 05:47:56 UTC
This vulnerability is out of security support scope for the following product:

 * Red Hat Mobile Application Platform

 Please refer to https://access.redhat.com/support/policy/updates/rhmap for more details

Comment 16 Joshua Padman 2019-08-12 02:26:02 UTC
This vulnerability is out of security support scope for the following products:
 * Red Hat JBoss Fuse 6
 * Red Hat JBoss BPM Suite 6
 * Red Hat JBoss A-MQ 6

Please refer to https://access.redhat.com/support/policy/updates/jboss_notes for more details.

Comment 20 errata-xmlrpc 2019-09-27 00:14:21 UTC
This issue has been addressed in the following products:

  Red Hat OpenShift Container Platform 4.1

Via RHSA-2019:2858 https://access.redhat.com/errata/RHSA-2019:2858

Comment 21 Product Security DevOps Team 2019-09-27 00:45:35 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2019-12086

Comment 22 errata-xmlrpc 2019-09-30 22:51:32 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 8

Via RHSA-2019:2937 https://access.redhat.com/errata/RHSA-2019:2937

Comment 23 errata-xmlrpc 2019-09-30 22:53:48 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6

Via RHSA-2019:2935 https://access.redhat.com/errata/RHSA-2019:2935

Comment 24 errata-xmlrpc 2019-09-30 22:55:53 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7

Via RHSA-2019:2936 https://access.redhat.com/errata/RHSA-2019:2936

Comment 25 errata-xmlrpc 2019-09-30 22:58:05 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2019:2938 https://access.redhat.com/errata/RHSA-2019:2938

Comment 27 errata-xmlrpc 2019-10-10 09:54:44 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes

Via RHSA-2019:2998 https://access.redhat.com/errata/RHSA-2019:2998

Comment 28 errata-xmlrpc 2019-10-14 18:28:38 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.3 for RHEL 6

Via RHSA-2019:3044 https://access.redhat.com/errata/RHSA-2019:3044

Comment 29 errata-xmlrpc 2019-10-14 18:28:58 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.3 for RHEL 7

Via RHSA-2019:3045 https://access.redhat.com/errata/RHSA-2019:3045

Comment 30 errata-xmlrpc 2019-10-14 18:29:16 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.3 for RHEL 8

Via RHSA-2019:3046 https://access.redhat.com/errata/RHSA-2019:3046

Comment 31 errata-xmlrpc 2019-10-14 18:59:24 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.3.4 zip

Via RHSA-2019:3050 https://access.redhat.com/errata/RHSA-2019:3050

Comment 32 errata-xmlrpc 2019-10-18 19:53:06 UTC
This issue has been addressed in the following products:

  Red Hat OpenShift Container Platform 3.11

Via RHSA-2019:3149 https://access.redhat.com/errata/RHSA-2019:3149

Comment 33 Paramvir jindal 2019-12-04 11:00:53 UTC
Marking RHDM and RHPAM as not affected as it ships jackson-databind-2.9.9.3-redhat-00002.jar which is already fixed.

Comment 38 Jonathan Christison 2020-02-28 14:26:44 UTC
Mitigation:

The following conditions are needed for an exploit, we recommend avoiding all if possible

* Deserialization from sources you do not control
* `enableDefaultTyping()`
* `@JsonTypeInfo using `id.CLASS` or `id.MINIMAL_CLASS`

Comment 39 Cedric Buissart 2020-03-19 16:17:03 UTC
Statement:

Red Hat Satellite 6 does not enable polymorphic unmarshmalling, which is a required configuration for the vulnerability to be used. We may update the jackson-databind dependency in a future release.

Comment 40 errata-xmlrpc 2020-04-14 13:22:07 UTC
This issue has been addressed in the following products:

  Red Hat Satellite 6.7 for RHEL 7

Via RHSA-2020:1454 https://access.redhat.com/errata/RHSA-2020:1454

Comment 41 errata-xmlrpc 2020-07-28 15:54:25 UTC
This issue has been addressed in the following products:

  Red Hat Fuse 7.7.0

Via RHSA-2020:3192 https://access.redhat.com/errata/RHSA-2020:3192


Note You need to log in before you can comment on or make changes to this bug.